from discord import ui, ButtonStyle, Interaction
from redbot.core import commands

from aurora.configuration.embed import embed
from aurora.utilities.config import config

class Overrides(ui.View):
    def __init__(self, ctx: commands.Context):
        super().__init__()
        self.ctx = ctx

    @ui.button(label="Auto Evidence Format", style=ButtonStyle.green)
    async def auto_evidenceformat(self, interaction: Interaction, button: ui.Button): # pylint: disable=unused-argument
        await interaction.response.defer(ephemeral=True)
        current_setting = await config.user(self.ctx.author).auto_evidenceformat()
        if current_setting is not None:
            await config.user(self.ctx.author).auto_evidenceformat.set(not current_setting)
        else:
            await config.user(self.ctx.author).auto_evidenceformat.set(True)
        if current_setting is True:
            response = "Auto Evidence Format disabled."
        else:
            response = "Auto Evidence Format enabled."
        await self.ctx.message.edit(embed=await embed(self.ctx))
        await interaction.followup.send(content=response, ephemeral=True)

    @ui.button(label="Ephemeral", style=ButtonStyle.green)
    async def ephemeral(self, interaction: Interaction, button: ui.Button): # pylint: disable=unused-argument
        await interaction.response.defer(ephemeral=True)
        current_setting = await config.user(self.ctx.author).history_ephemeral()
        if current_setting:
            await config.user(self.ctx.author).history_ephemeral.set(not current_setting)
        else:
            await config.user(self.ctx.author).history_ephemeral.set(True)
        if current_setting is True:
            response = "Ephemeral disabled."
        else:
            response = "Ephemeral enabled."
        await self.ctx.message.edit(embed=await embed(self.ctx))
        await interaction.followup.send(content=response, ephemeral=True)

    @ui.button(label="Inline", style=ButtonStyle.green)
    async def inline(self, interaction: Interaction, button: ui.Button): # pylint: disable=unused-argument
        await interaction.response.defer(ephemeral=True)
        current_setting = await config.user(self.ctx.author).history_inline()
        if current_setting:
            await config.user(self.ctx.author).history_inline.set(not current_setting)
        else:
            await config.user(self.ctx.author).history_inline.set(True)
        if current_setting is True:
            response = "Inline disabled."
        else:
            response = "Inline enabled."
        await self.ctx.message.edit(embed=await embed(self.ctx))
        await interaction.followup.send(content=response, ephemeral=True)
